blob: ade8e177730d21032effc45f5e419f659715d3eb [file] [log] [blame]
Frédéric Lécaille51e01b52018-11-29 21:41:42 +01001#!/bin/sh
PiBa-NL72504042018-11-27 22:26:38 +01002
Christopher Faulet8d67cf82018-12-18 22:41:20 +01003_help()
4{
PiBa-NL72504042018-11-27 22:26:38 +01005 cat << EOF
6### run-regtests.sh ###
7 Running run-regtests.sh --help shows this information about how to use it
8
9 Run without parameters to run all tests in the current folder (including subfolders)
10 run-regtests.sh
11
12 Provide paths to run tests from (including subfolders):
13 run-regtests.sh ./tests1 ./tests2
14
15 Parameters:
Frédéric Lécaille43361232019-01-11 10:10:21 +010016 --j <NUM>, To run vtest with multiple jobs / threads for a faster overall result
PiBa-NL72504042018-11-27 22:26:38 +010017 run-regtests.sh ./fasttest --j 16
18
19 --v, to run verbose
Frédéric Lécaille43361232019-01-11 10:10:21 +010020 run-regtests.sh --v, disables the default vtest 'quiet' parameter
PiBa-NL72504042018-11-27 22:26:38 +010021
Christopher Faulet2a7cf922018-12-19 10:22:01 +010022 --debug to show test logs on standard ouput (implies --v)
23 run-regtests.sh --debug
24
Christopher Faulet9c6df5e2018-12-19 10:25:07 +010025 --keep-logs to keep all log directories (by default kept if test fails)
26 run-regtests.sh --keep-logs
27
Frédéric Lécaille43361232019-01-11 10:10:21 +010028 --vtestparams <ARGS>, passes custom ARGS to vtest
29 run-regtests.sh --vtestparams "-n 10"
PiBa-NL72504042018-11-27 22:26:38 +010030
Frédéric Lécailledc1a3bd2019-03-29 15:07:24 +010031 --type <reg tests types> filter the types of the tests to be run, depending on
32 the commented REGTESTS_TYPE variable value in each VTC file.
33 The value of REGTESTS_TYPE supported are: default, slow, bug, broken and
34 experimental. When not specified, it is set to 'default' as default value.
35
36 run-regtest.sh --type slow,default
37
Christopher Faulet8d0fdf52018-12-19 10:18:40 +010038 --clean to cleanup previous reg-tests log directories and exit
39 run-regtests.sh --clean
40
Christopher Faulet78f31bf2019-04-12 16:53:41 +020041 --use-htx to use the HTX in tests (deprecated, the default mode now)
42
43 --no-htx to use the legacy HTTP in tests
44 run-regtests.sh --no-htx, sets the macro \${no-htx}
Christopher Fauletfa6798f2018-12-19 11:22:04 +010045 In .vtc files, in HAProxy configuration, you should use the following line
46 to "templatize" your tests:
47
48 \${no-htx} option http-use-htx
49
PiBa-NL72504042018-11-27 22:26:38 +010050 Including text below into a .vtc file will check for its requirements
51 related to haproxy's target and compilation options
Bertrand Jacquin7e30b502019-05-16 22:15:31 +010052 # Below targets are not capable of completing this test successfully
PiBa-NL72504042018-11-27 22:26:38 +010053 #EXCLUDE_TARGET=freebsd, abns sockets are not available on freebsd
54
55 #EXCLUDE_TARGETS=dos,freebsd,windows
56
Bertrand Jacquin7e30b502019-05-16 22:15:31 +010057 # Below option is required to complete this test successfully
PiBa-NL72504042018-11-27 22:26:38 +010058 #REQUIRE_OPTION=OPENSSL, this test needs OPENSSL compiled in.
59
Christopher Faulet7e245df2018-12-21 15:18:02 +010060 #REQUIRE_OPTIONS=ZLIB|SLZ,OPENSSL,LUA
PiBa-NL72504042018-11-27 22:26:38 +010061
62 # To define a range of versions that a test can run with:
63 #REQUIRE_VERSION=0.0
64 #REQUIRE_VERSION_BELOW=99.9
65
Frédéric Lécaille43361232019-01-11 10:10:21 +010066 Configure environment variables to set the haproxy and vtest binaries to use
PiBa-NL72504042018-11-27 22:26:38 +010067 setenv HAPROXY_PROGRAM /usr/local/sbin/haproxy
Frédéric Lécaille43361232019-01-11 10:10:21 +010068 setenv VTEST_PROGRAM /usr/local/bin/vtest
Willy Tarreaue35bb172020-12-16 10:39:20 +010069 setenv HAPROXY_ARGS "-dM -de -m 50"
Frederic Lecailled4f36e32018-12-13 22:15:05 +010070 or
71 export HAPROXY_PROGRAM=/usr/local/sbin/haproxy
Frédéric Lécaille43361232019-01-11 10:10:21 +010072 export VTEST_PROGRAM=/usr/local/bin/vtest
Willy Tarreaue35bb172020-12-16 10:39:20 +010073 export HAPROXY_ARGS="-dM -de -m 50"
PiBa-NL72504042018-11-27 22:26:38 +010074EOF
Christopher Faulet8d67cf82018-12-18 22:41:20 +010075 exit 0
76}
PiBa-NL72504042018-11-27 22:26:38 +010077
Frederic Lecailled4f36e32018-12-13 22:15:05 +010078add_range_to_test_list()
79{
80 level0="*.vtc"
81 level1="h*.vtc"
82 level2="s*.vtc"
83 level3="l*.vtc"
84 level4="b*.vtc"
85 level5="k*.vtc"
86 level6="e*.vtc"
87
88 new_range=$(echo $1 | tr '-' ' ')
89 non_digit=$(echo $new_range | grep '[^0-9 ]')
90 if [ -n "$non_digit" ] ; then
91 return
92 fi
93 if [ "$new_range" = "$1" ] ; then
94 if [ $1 -gt 6 ] ; then
95 return
96 fi
97 eval echo '$'level$1
98 return
99 fi
100 if [ -z "$new_range" ] ; then
101 return
102 fi
103 list=
104 for l in $(seq $new_range) ; do
105 if [ -n "l" ] ; then
106 if [ -z "$list" ] ; then
107 list="$(eval echo '$'level${l})"
108 else
109 list="$list $(eval echo '$'level${l})"
110 fi
111 fi
112 done
113
114 echo $list
115}
116
PiBa-NL72504042018-11-27 22:26:38 +0100117_startswith() {
118 _str="$1"
119 _sub="$2"
120 echo "$_str" | grep "^$_sub" >/dev/null 2>&1
121}
122
123_findtests() {
124 set -f
PiBa-NL72504042018-11-27 22:26:38 +0100125
William Lallemandc11a1002021-02-05 11:27:54 +0100126 REGTESTS_TYPES="${REGTESTS_TYPES:-default,bug,devel,slow}"
Frédéric Lécailledc1a3bd2019-03-29 15:07:24 +0100127 any_test=$(echo $REGTESTS_TYPES | grep -cw "any")
128 for i in $( find "$1" -name *.vtc ); do
PiBa-NL72504042018-11-27 22:26:38 +0100129 skiptest=
Willy Tarreau939193a2018-12-06 15:49:27 +0100130 require_version="$(sed -ne 's/^#REQUIRE_VERSION=//p' "$i")"
131 require_version_below="$(sed -ne 's/^#REQUIRE_VERSION_BELOW=//p' "$i")"
Christopher Faulet7e245df2018-12-21 15:18:02 +0100132 require_options="$(sed -ne 's/^#REQUIRE_OPTIONS=//p' "$i" | sed -e 's/,/ /g')"
133 exclude_targets="$(sed -ne 's/^#EXCLUDE_TARGETS=//p' "$i" | sed -e 's/,/ /g')"
Frédéric Lécailledc1a3bd2019-03-29 15:07:24 +0100134 if [ $any_test -ne 1 ] ; then
135 regtest_type="$(sed -ne 's/^#REGTEST_TYPE=//p' "$i")"
136 if [ -z $regtest_type ] ; then
137 regtest_type=default
138 fi
139 if ! $(echo $REGTESTS_TYPES | grep -wq $regtest_type) ; then
140 echo " Skip $i because its type '"$regtest_type"' is excluded"
141 skiptest=1
142 fi
143 fi
Christopher Faulet7e245df2018-12-21 15:18:02 +0100144
145 requiredoption="$(sed -ne 's/^#REQUIRE_OPTION=//p' "$i" | sed -e 's/,.*//')"
146 if [ -n "$requiredoption" ]; then
147 require_options="$require_options $requiredoption"
148 fi
149
150 excludedtarget="$(sed -ne 's/^#EXCLUDE_TARGET=//p' "$i" | sed -e 's/,.*//')"
151 if [ -n "$excludedtarget" ]; then
152 exclude_targets="$exclude_targets $excludedtarget"
153 fi
PiBa-NL72504042018-11-27 22:26:38 +0100154
155 if [ -n "$require_version" ]; then
156 if [ $(_version "$HAPROXY_VERSION") -lt $(_version "$require_version") ]; then
157 echo " Skip $i because option haproxy is version: $HAPROXY_VERSION"
158 echo " REASON: this test requires at least version: $require_version"
159 skiptest=1
160 fi
161 fi
162 if [ -n "$require_version_below" ]; then
163 if [ $(_version "$HAPROXY_VERSION") -ge $(_version "$require_version_below") ]; then
164 echo " Skip $i because option haproxy is version: $HAPROXY_VERSION"
165 echo " REASON: this test requires a version below: $require_version_below"
166 skiptest=1
167 fi
168 fi
169
Christopher Faulet7e245df2018-12-21 15:18:02 +0100170 for excludedtarget in $exclude_targets; do
171 if [ "$excludedtarget" = "$TARGET" ]; then
172 echo " Skip $i because haproxy is compiled for the excluded target $TARGET"
PiBa-NL72504042018-11-27 22:26:38 +0100173 skiptest=1
174 fi
175 done
Christopher Faulet7e245df2018-12-21 15:18:02 +0100176
177 for requiredoption in $require_options; do
178 alternatives=$(echo "$requiredoption" | sed -e 's/|/ /g')
179 found=
180 for alt in $alternatives; do
Willy Tarreau87586e12019-03-27 13:52:39 +0100181 if echo "$FEATURES" | grep -qw "\+$alt"; then
Christopher Faulet7e245df2018-12-21 15:18:02 +0100182 found=1;
183 fi
184 done
185 if [ -z $found ]; then
186 echo " Skip $i because haproxy is not compiled with the required option $requiredoption"
PiBa-NL72504042018-11-27 22:26:38 +0100187 skiptest=1
188 fi
189 done
PiBa-NL72504042018-11-27 22:26:38 +0100190
191 if [ -z $skiptest ]; then
192 echo " Add test: $i"
193 testlist="$testlist $i"
194 fi
195 done
196}
197
Christopher Faulet8d0fdf52018-12-19 10:18:40 +0100198_cleanup()
199{
200 DIRS=$(find "${TESTDIR}" -maxdepth 1 -type d -name "haregtests-*" -exec basename {} \; 2>/dev/null)
201 if [ -z "${DIRS}" ]; then
202 echo "No reg-tests log directory found"
203 else
204 echo "Cleanup following reg-tests log directories:"
205 for d in ${DIRS}; do
206 echo " o ${TESTDIR}/$d"
207 done
208 read -p "Continue (y/n)?" reply
209 case "$reply" in
210 y|Y)
211 for d in ${DIRS}; do
212 rm -r "${TESTDIR}/$d"
213 done
214 echo "done"
215 exit 0
216 ;;
217 *)
218 echo "aborted"
219 exit 1
220 ;;
221 esac
222 fi
223}
224
225
PiBa-NL72504042018-11-27 22:26:38 +0100226_process() {
PiBa-NL72504042018-11-27 22:26:38 +0100227 while [ ${#} -gt 0 ]; do
228 if _startswith "$1" "-"; then
229 case "${1}" in
230 --j)
231 jobcount="$2"
232 shift
233 ;;
Frédéric Lécaille43361232019-01-11 10:10:21 +0100234 --vtestparams)
235 vtestparams="$2"
PiBa-NL72504042018-11-27 22:26:38 +0100236 shift
237 ;;
238 --v)
239 verbose=""
Christopher Faulet2a7cf922018-12-19 10:22:01 +0100240 ;;
241 --debug)
242 verbose=""
243 debug="-v"
PiBa-NL72504042018-11-27 22:26:38 +0100244 ;;
Christopher Faulet9c6df5e2018-12-19 10:25:07 +0100245 --keep-logs)
246 keep_logs="-L"
247 ;;
Frédéric Lécailledc1a3bd2019-03-29 15:07:24 +0100248 --type)
249 REGTESTS_TYPES="$2"
250 shift
251 ;;
Christopher Fauletfa6798f2018-12-19 11:22:04 +0100252 --use-htx)
253 no_htx=""
254 ;;
Christopher Faulet78f31bf2019-04-12 16:53:41 +0200255 --no-htx)
256 no_htx="no "
257 ;;
Christopher Faulet8d0fdf52018-12-19 10:18:40 +0100258 --clean)
259 _cleanup
260 exit 0
261 ;;
Christopher Faulet8d67cf82018-12-18 22:41:20 +0100262 --help)
263 _help
264 ;;
PiBa-NL72504042018-11-27 22:26:38 +0100265 *)
266 echo "Unknown parameter : $1"
Christopher Faulet8d67cf82018-12-18 22:41:20 +0100267 exit 1
PiBa-NL72504042018-11-27 22:26:38 +0100268 ;;
269 esac
270 else
Christopher Faulet8d67cf82018-12-18 22:41:20 +0100271 REGTESTS="${REGTESTS} $1"
PiBa-NL72504042018-11-27 22:26:38 +0100272 fi
273 shift 1
274 done
PiBa-NL72504042018-11-27 22:26:38 +0100275}
276
277_version() {
278 echo "$@" | awk -F. '{ printf("%d%03d%03d%03d\012", $1,$2,$3,$4); }';
279}
280
PiBa-NL72504042018-11-27 22:26:38 +0100281
Frédéric Lécaille51e01b52018-11-29 21:41:42 +0100282HAPROXY_PROGRAM="${HAPROXY_PROGRAM:-${PWD}/haproxy}"
Willy Tarreaue35bb172020-12-16 10:39:20 +0100283HAPROXY_ARGS="${HAPROXY_ARGS--dM}"
Frédéric Lécaille43361232019-01-11 10:10:21 +0100284VTEST_PROGRAM="${VTEST_PROGRAM:-vtest}"
Christopher Faulet8d0fdf52018-12-19 10:18:40 +0100285TESTDIR="${TMPDIR:-/tmp}"
Christopher Faulet8d67cf82018-12-18 22:41:20 +0100286REGTESTS=""
287
288jobcount=""
289verbose="-q"
Christopher Faulet2a7cf922018-12-19 10:22:01 +0100290debug=""
Christopher Faulet9c6df5e2018-12-19 10:25:07 +0100291keep_logs="-l"
Christopher Faulet78f31bf2019-04-12 16:53:41 +0200292no_htx=""
Christopher Faulet8d67cf82018-12-18 22:41:20 +0100293testlist=""
294
295_process "$@";
296
297echo ""
298echo "########################## Preparing to run tests ##########################"
PiBa-NL72504042018-11-27 22:26:38 +0100299
300preparefailed=
301if ! [ -x "$(command -v $HAPROXY_PROGRAM)" ]; then
302 echo "haproxy not found in path, please specify HAPROXY_PROGRAM environment variable"
303 preparefailed=1
304fi
Frédéric Lécaille43361232019-01-11 10:10:21 +0100305if ! [ -x "$(command -v $VTEST_PROGRAM)" ]; then
306 echo "vtest not found in path, please specify VTEST_PROGRAM environment variable"
PiBa-NL72504042018-11-27 22:26:38 +0100307 preparefailed=1
308fi
309if [ $preparefailed ]; then
310 exit 1
311fi
312
Willy Tarreauad25c262019-03-27 14:00:10 +0100313{ read HAPROXY_VERSION; read TARGET; read FEATURES; } << EOF
Willy Tarreaue35bb172020-12-16 10:39:20 +0100314$($HAPROXY_PROGRAM $HAPROXY_ARGS -vv |grep 'HA-Proxy version\|TARGET.*=\|^Feature' | sed 's/.* [:=] //')
PiBa-NL72504042018-11-27 22:26:38 +0100315EOF
316
317HAPROXY_VERSION=$(echo $HAPROXY_VERSION | cut -d " " -f 3)
318echo "Testing with haproxy version: $HAPROXY_VERSION"
319
320TESTRUNDATETIME="$(date '+%Y-%m-%d_%H-%M-%S')"
321
Frédéric Lécaille51e01b52018-11-29 21:41:42 +0100322mkdir -p "$TESTDIR" || exit 1
Christopher Faulet8d0fdf52018-12-19 10:18:40 +0100323TESTDIR=$(mktemp -d "$TESTDIR/haregtests-$TESTRUNDATETIME.XXXXXX") || exit 1
PiBa-NL72504042018-11-27 22:26:38 +0100324
Frédéric Lécaille51e01b52018-11-29 21:41:42 +0100325export TMPDIR="$TESTDIR"
326export HAPROXY_PROGRAM="$HAPROXY_PROGRAM"
Willy Tarreaue35bb172020-12-16 10:39:20 +0100327if [ -n "$HAPROXY_ARGS" ]; then
328 export HAPROXY_ARGS
329fi
PiBa-NL72504042018-11-27 22:26:38 +0100330
PiBa-NL72504042018-11-27 22:26:38 +0100331echo "Target : $TARGET"
Willy Tarreau87586e12019-03-27 13:52:39 +0100332echo "Options : $FEATURES"
PiBa-NL72504042018-11-27 22:26:38 +0100333
334echo "########################## Gathering tests to run ##########################"
Christopher Faulet78f31bf2019-04-12 16:53:41 +0200335# if htx is enable, but HAProxy version is lower to 1.9, disable it
336if [ $(_version "$HAPROXY_VERSION") -lt $(_version "1.9") ]; then
337 no_htx="#"
Christopher Fauletfa6798f2018-12-19 11:22:04 +0100338fi
339
Christopher Faulet8d67cf82018-12-18 22:41:20 +0100340if [ -z "$REGTESTS" ]; then
Willy Tarreauca8df4c2019-04-23 16:09:50 +0200341 _findtests reg-tests/
Christopher Faulet8d67cf82018-12-18 22:41:20 +0100342else
343 for t in $REGTESTS; do
344 _findtests $t
345 done
346fi
PiBa-NL72504042018-11-27 22:26:38 +0100347
Frédéric Lécaille43361232019-01-11 10:10:21 +0100348echo "########################## Starting vtest ##########################"
PiBa-NL72504042018-11-27 22:26:38 +0100349echo "Testing with haproxy version: $HAPROXY_VERSION"
350_vtresult=0
351if [ -n "$testlist" ]; then
352 if [ -n "$jobcount" ]; then
353 jobcount="-j $jobcount"
354 fi
Frédéric Lécaille85a7ea02019-04-25 20:14:43 +0200355 cmd="$VTEST_PROGRAM -b $((2<<20)) -k -t 10 -Dno-htx=${no_htx} $keep_logs $verbose $debug $jobcount $vtestparams $testlist"
Christopher Faulet1ecf0ea2018-12-18 22:47:23 +0100356 eval $cmd
PiBa-NL72504042018-11-27 22:26:38 +0100357 _vtresult=$?
358else
359 echo "No tests found that meet the required criteria"
360fi
Christopher Faulet9c6df5e2018-12-19 10:25:07 +0100361
362
363if [ $_vtresult -eq 0 ]; then
Bertrand Jacquin7e30b502019-05-16 22:15:31 +0100364 # all tests were successful, removing tempdir (the last part.)
Christopher Faulet9c6df5e2018-12-19 10:25:07 +0100365 # ignore errors is the directory is not empty or if it does not exist
366 rmdir "$TESTDIR" 2>/dev/null
367fi
368
369if [ -d "${TESTDIR}" ]; then
370 echo "########################## Gathering results ##########################"
Frédéric Lécaille51e01b52018-11-29 21:41:42 +0100371 export TESTDIR
372 find "$TESTDIR" -type d -name "vtc.*" -exec sh -c 'for i; do
373 if [ ! -e "$i/LOG" ] ; then continue; fi
Christopher Faulet9c6df5e2018-12-19 10:25:07 +0100374
Frédéric Lécaille51e01b52018-11-29 21:41:42 +0100375 cat <<- EOF | tee -a "$TESTDIR/failedtests.log"
376$(echo "###### $(cat "$i/INFO") ######")
377$(echo "## test results in: \"$i\"")
Frédéric Lécaillef9a48ef2019-01-08 11:30:28 +0100378$(grep -E -- "^(----|\* diag)" "$i/LOG")
PiBa-NL72504042018-11-27 22:26:38 +0100379EOF
Frédéric Lécaille51e01b52018-11-29 21:41:42 +0100380 done' sh {} +
PiBa-NL72504042018-11-27 22:26:38 +0100381fi
Christopher Faulet9c6df5e2018-12-19 10:25:07 +0100382
383exit $_vtresult